import * as i0 from '@angular/core';
import { inject, Component, CUSTOM_ELEMENTS_SCHEMA, ChangeDetectionStrategy, input, Directive, computed, viewChild, effect, untracked } from '@angular/core';
import { injectStore, pick, extend, getInstanceState, injectBeforeRender, NgtArgs, vector2, omit, resolveRef, vector3, is, NgtSelection } from 'angular-three';
import { createNoopInjectionToken } from 'ngxtension/create-injection-token';
import { mergeInputs } from 'ngxtension/inject-inputs';
import { EffectAttribute, EffectComposer, RenderPass, NormalPass, DepthDownsamplingPass, Effect, EffectPass, Pass, BloomEffect, BlendFunction, BrightnessContrastEffect, ChromaticAberrationEffect, ColorAverageEffect, ColorDepthEffect, DepthEffect, DepthOfFieldEffect, MaskFunction, DotScreenEffect, FXAAEffect, GlitchEffect, GlitchMode, GodRaysEffect, GridEffect, HueSaturationEffect, LUT3DEffect, NoiseEffect, OutlineEffect, PixelationEffect, ScanlineEffect, SelectiveBloomEffect, SepiaEffect, ShockWaveEffect, SMAAEffect, TiltShiftEffect, ToneMappingEffect, VignetteEffect } from 'postprocessing';
import * as THREE from 'three';
import { Group } from 'three';
import { isWebGL2Available } from 'three-stdlib';
import { easing } from 'maath';

const [injectDefaultEffectOptions, provideDefaultEffectOptions] = createNoopInjectionToken('Default Effect options');
class NgtpEffectBlendMode {
    constructor() {
        this.effect = inject(NgtpEffect, { optional: true });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpEffectBlendMode, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.1.5", type: NgtpEffectBlendMode, isStandalone: true, selector: "ngtp-effect-blend-mode", ngImport: i0, template: `
		@if (effect) {
			<ngt-value [rawValue]="effect.blendFunction()" attach="blendMode.blendFunction" />
			<ngt-value [rawValue]="effect.opacity()" attach="blendMode.opacity.value" />
		}
	`, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpEffectBlendMode, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-effect-blend-mode',
                    template: `
		@if (effect) {
			<ngt-value [rawValue]="effect.blendFunction()" attach="blendMode.blendFunction" />
			<ngt-value [rawValue]="effect.opacity()" attach="blendMode.opacity.value" />
		}
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                }]
        }] });
class NgtpEffect {
    constructor() {
        this.defaultEffectOptions = injectDefaultEffectOptions({ optional: true });
        this.blendFunction = input(this.defaultEffectOptions?.blendFunction);
        this.opacity = input(this.defaultEffectOptions?.opacity);
        this.store = injectStore();
        this.camera = this.store.camera;
        this.invalidate = this.store.invalidate;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpEffect, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "17.1.0", version: "19.1.5", type: NgtpEffect, isStandalone: true, inputs: { blendFunction: { classPropertyName: "blendFunction", publicName: "blendFunction", isSignal: true, isRequired: false, transformFunction: null }, opacity: { classPropertyName: "opacity", publicName: "opacity", isSignal: true, isRequired: false, transformFunction: null } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpEffect, decorators: [{
            type: Directive
        }] });

const defaultOptions$5 = {
    enabled: true,
    renderPriority: 1,
    autoClear: true,
    multisampling: 8,
    frameBufferType: THREE.HalfFloatType,
};
function isConvolution(effect) {
    return (effect.getAttributes() & EffectAttribute.CONVOLUTION) === EffectAttribute.CONVOLUTION;
}
class NgtpEffectComposer {
    constructor() {
        this.options = input(defaultOptions$5, { transform: mergeInputs(defaultOptions$5) });
        this.store = injectStore();
        this.depthBuffer = pick(this.options, 'depthBuffer');
        this.stencilBuffer = pick(this.options, 'stencilBuffer');
        this.multisampling = pick(this.options, 'multisampling');
        this.frameBufferType = pick(this.options, 'frameBufferType');
        this.enableNormalPass = pick(this.options, 'enableNormalPass');
        this.resolutionScale = pick(this.options, 'resolutionScale');
        this.enabled = pick(this.options, 'enabled');
        this.renderPriority = pick(this.options, 'renderPriority');
        this.scene = computed(() => this.options().scene ?? this.store.scene());
        this.camera = computed(() => this.options().camera ?? this.store.camera());
        this.groupRef = viewChild.required('group');
        this.priority = computed(() => {
            const enabled = this.enabled();
            if (!enabled)
                return 0;
            return this.renderPriority();
        });
        this.composerData = computed(() => {
            const webGL2Available = isWebGL2Available();
            const [gl, scene, camera, depthBuffer, stencilBuffer, multisampling, frameBufferType, enableNormalPass, resolutionScale,] = [
                this.store.gl(),
                this.scene(),
                this.camera(),
                this.depthBuffer(),
                this.stencilBuffer(),
                this.multisampling(),
                this.frameBufferType(),
                this.enableNormalPass(),
                this.resolutionScale(),
            ];
            // initialize composer
            const composer = new EffectComposer(gl, {
                depthBuffer,
                stencilBuffer,
                multisampling: multisampling > 0 && webGL2Available ? multisampling : 0,
                frameBufferType,
            });
            // add render pass
            composer.addPass(new RenderPass(scene, camera));
            // create normal pass
            let downSamplingPass = null;
            let normalPass = null;
            if (enableNormalPass) {
                normalPass = new NormalPass(scene, camera);
                normalPass.enabled = false;
                composer.addPass(normalPass);
                if (resolutionScale !== undefined && webGL2Available) {
                    downSamplingPass = new DepthDownsamplingPass({ normalBuffer: normalPass.texture, resolutionScale });
                    downSamplingPass.enabled = false;
                    composer.addPass(downSamplingPass);
                }
            }
            return { composer, normalPass, downSamplingPass };
        });
        this.effectComposer = pick(this.composerData, 'composer');
        extend({ Group });
        // NOTE: Disable tone mapping because threejs disallows tonemapping on render targets
        effect((onCleanup) => {
            const gl = this.store.gl();
            const currentTonemapping = gl.toneMapping;
            gl.toneMapping = THREE.NoToneMapping;
            onCleanup(() => {
                gl.toneMapping = currentTonemapping;
            });
        });
        effect(() => {
            const [composer, width, height] = [
                this.effectComposer(),
                this.store.size.width(),
                this.store.size.height(),
            ];
            if (composer) {
                composer.setSize(width, height);
            }
        });
        effect((onCleanup) => {
            const [group, { composer, normalPass, downSamplingPass }, camera] = [
                this.groupRef().nativeElement,
                this.composerData(),
                this.camera(),
            ];
            const passes = [];
            if (composer) {
                const instanceState = getInstanceState(group);
                if (!instanceState)
                    return;
                const children = instanceState.nonObjects();
                for (let i = 0; i < children.length; i++) {
                    const child = children[i];
                    if (child instanceof Effect) {
                        const effects = [child];
                        if (!isConvolution(child)) {
                            let next = null;
                            while ((next = children[i + 1]) instanceof Effect) {
                                if (isConvolution(next))
                                    break;
                                effects.push(next);
                                i++;
                            }
                        }
                        const pass = new EffectPass(camera, ...effects);
                        passes.push(pass);
                    }
                    else if (child instanceof Pass) {
                        passes.push(child);
                    }
                }
                for (const pass of passes) {
                    composer.addPass(pass);
                }
                if (normalPass)
                    normalPass.enabled = true;
                if (downSamplingPass)
                    downSamplingPass.enabled = true;
            }
            onCleanup(() => {
                for (const pass of passes)
                    composer?.removePass(pass);
                if (normalPass)
                    normalPass.enabled = false;
                if (downSamplingPass)
                    downSamplingPass.enabled = false;
            });
        });
        injectBeforeRender(({ delta }) => {
            const [composer, { enabled, autoClear, stencilBuffer }, gl] = [
                this.effectComposer(),
                this.options(),
                this.store.snapshot.gl,
            ];
            if (enabled) {
                const currentAutoClear = gl.autoClear;
                gl.autoClear = autoClear;
                if (stencilBuffer && !autoClear)
                    gl.clearStencil();
                composer.render(delta);
                gl.autoClear = currentAutoClear;
            }
        }, { priority: this.priority });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpEffectComposer, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.2.0", version: "19.1.5", type: NgtpEffectComposer, isStandalone: true, selector: "ngtp-effect-composer", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, viewQueries: [{ propertyName: "groupRef", first: true, predicate: ["group"], descendants: true, isSignal: true }], ngImport: i0, template: `
		<ngt-group #group>
			<ng-content />
		</ngt-group>
	`, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpEffectComposer, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-effect-composer',
                    template: `
		<ngt-group #group>
			<ng-content />
		</ngt-group>
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                }]
        }], ctorParameters: () => [] });

const fragment = /* language=glsl glsl */ `
uniform sampler2D uCharacters;
uniform float uCharactersCount;
uniform float uCellSize;
uniform bool uInvert;
uniform vec3 uColor;

const vec2 SIZE = vec2(16.);

vec3 greyscale(vec3 color, float strength) {
    float g = dot(color, vec3(0.299, 0.587, 0.114));
    return mix(color, vec3(g), strength);
}

vec3 greyscale(vec3 color) {
    return greyscale(color, 1.0);
}

void mainImage(const in vec4 inputColor, const in vec2 uv, out vec4 outputColor) {
    vec2 cell = resolution / uCellSize;
    vec2 grid = 1.0 / cell;
    vec2 pixelizedUV = grid * (0.5 + floor(uv / grid));
    vec4 pixelized = texture2D(inputBuffer, pixelizedUV);
    float greyscaled = greyscale(pixelized.rgb).r;

    if (uInvert) {
        greyscaled = 1.0 - greyscaled;
    }

    float characterIndex = floor((uCharactersCount - 1.0) * greyscaled);
    vec2 characterPosition = vec2(mod(characterIndex, SIZE.x), floor(characterIndex / SIZE.y));
    vec2 offset = vec2(characterPosition.x, -characterPosition.y) / SIZE;
    vec2 charUV = mod(uv * (cell / SIZE), 1.0 / SIZE) - vec2(0., 1.0 / SIZE) + offset;
    vec4 asciiCharacter = texture2D(uCharacters, charUV);

    asciiCharacter.rgb = uColor * asciiCharacter.r;
    asciiCharacter.a = pixelized.a;
    outputColor = asciiCharacter;
}
`;
class ASCIIEffect extends Effect {
    constructor({ font = 'arial', characters = ` .:,'-^=*+?!|0#X%WM@`, fontSize = 54, cellSize = 16, color = '#ffffff', invert = false, } = {}) {
        const uniforms = new Map([
            ['uCharacters', new THREE.Uniform(new THREE.Texture())],
            ['uCellSize', new THREE.Uniform(cellSize)],
            ['uCharactersCount', new THREE.Uniform(characters.length)],
            ['uColor', new THREE.Uniform(new THREE.Color(color))],
            ['uInvert', new THREE.Uniform(invert)],
        ]);
        super('ASCIIEffect', fragment, { uniforms });
        const charactersTextureUniform = this.uniforms.get('uCharacters');
        if (charactersTextureUniform) {
            charactersTextureUniform.value = this.createCharactersTexture(characters, font, fontSize);
        }
    }
    /** Draws the characters on a Canvas and returns a texture */
    createCharactersTexture(characters, font, fontSize) {
        const canvas = document.createElement('canvas');
        const SIZE = 1024;
        const MAX_PER_ROW = 16;
        const CELL = SIZE / MAX_PER_ROW;
        canvas.width = canvas.height = SIZE;
        const texture = new THREE.CanvasTexture(canvas, undefined, THREE.RepeatWrapping, THREE.RepeatWrapping, THREE.NearestFilter, THREE.NearestFilter);
        const context = canvas.getContext('2d');
        if (!context) {
            throw new Error('Context not available');
        }
        context.clearRect(0, 0, SIZE, SIZE);
        context.font = `${fontSize}px ${font}`;
        context.textAlign = 'center';
        context.textBaseline = 'middle';
        context.fillStyle = '#fff';
        for (let i = 0; i < characters.length; i++) {
            const char = characters[i];
            const x = i % MAX_PER_ROW;
            const y = Math.floor(i / MAX_PER_ROW);
            context.fillText(char, x * CELL + CELL / 2, y * CELL + CELL / 2);
        }
        texture.needsUpdate = true;
        return texture;
    }
}
const defaultOptions$4 = {
    font: 'arial',
    characters: ` .:,'-^=*+?!|0#X%WM@`,
    fontSize: 54,
    cellSize: 16,
    color: '#ffffff',
    invert: false,
};
class NgtpASCII {
    constructor() {
        this.options = input(defaultOptions$4, { transform: mergeInputs(defaultOptions$4) });
        this.effect = computed(() => new ASCIIEffect(this.options()));
        effect((onCleanup) => {
            const effect = this.effect();
            onCleanup(() => effect.dispose());
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpASCII, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpASCII, isStandalone: true, selector: "ngtp-ascii", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, ngImport: i0, template: `
		<ngt-primitive *args="[effect()]" />
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpASCII, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-ascii',
                    template: `
		<ngt-primitive *args="[effect()]" />
	`,
                    imports: [NgtArgs],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                }]
        }], ctorParameters: () => [] });

class NgtpBloom {
    constructor() {
        this.options = input({});
        this.effect = inject(NgtpEffect, { host: true });
        extend({ BloomEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpBloom, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpBloom, isStandalone: true, selector: "ngtp-bloom", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, providers: [provideDefaultEffectOptions({ blendFunction: BlendFunction.ADD })], hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-bloom-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-bloom-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpBloom, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-bloom',
                    template: `
		<ngt-bloom-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-bloom-effect>
	`,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                    providers: [provideDefaultEffectOptions({ blendFunction: BlendFunction.ADD })],
                }]
        }], ctorParameters: () => [] });

class NgtpBrightnessContrast {
    constructor() {
        this.options = input({});
        this.effect = inject(NgtpEffect, { host: true });
        extend({ BrightnessContrastEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpBrightnessContrast, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpBrightnessContrast, isStandalone: true, selector: "ngtp-brightness-contrast", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-brightness-contrast-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-brightness-contrast-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpBrightnessContrast, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-brightness-contrast',
                    template: `
		<ngt-brightness-contrast-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-brightness-contrast-effect>
	`,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                }]
        }], ctorParameters: () => [] });

class NgtpChromaticAberration {
    constructor() {
        this.options = input({});
        this.effect = inject(NgtpEffect, { host: true });
        extend({ ChromaticAberrationEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpChromaticAberration, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpChromaticAberration, isStandalone: true, selector: "ngtp-chromatic-aberration", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-chromatic-aberration-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-chromatic-aberration-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpChromaticAberration, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-chromatic-aberration',
                    template: `
		<ngt-chromatic-aberration-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-chromatic-aberration-effect>
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                }]
        }], ctorParameters: () => [] });

class NgtpColorAverage {
    constructor() {
        this.options = input({ blendFunction: BlendFunction.NORMAL }, { transform: mergeInputs({ blendFunction: BlendFunction.NORMAL }) });
        extend({ ColorAverageEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpColorAverage, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpColorAverage, isStandalone: true, selector: "ngtp-color-average", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, ngImport: i0, template: `
		<ngt-color-average-effect *args="[options().blendFunction]">
			<ng-content />
		</ngt-color-average-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpColorAverage, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-color-average',
                    template: `
		<ngt-color-average-effect *args="[options().blendFunction]">
			<ng-content />
		</ngt-color-average-effect>
	`,
                    imports: [NgtArgs],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                }]
        }], ctorParameters: () => [] });

class NgtpColorDepth {
    constructor() {
        this.options = input({});
        this.effect = inject(NgtpEffect, { host: true });
        extend({ ColorDepthEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpColorDepth, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpColorDepth, isStandalone: true, selector: "ngtp-color-depth", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-color-depth-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-color-depth-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpColorDepth, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-color-depth',
                    template: `
		<ngt-color-depth-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-color-depth-effect>
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                }]
        }], ctorParameters: () => [] });

class NgtpDepth {
    constructor() {
        this.options = input({});
        this.effect = inject(NgtpEffect, { host: true });
        extend({ DepthEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpDepth, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpDepth, isStandalone: true, selector: "ngtp-depth", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-depth-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-depth-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpDepth, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-depth',
                    template: `
		<ngt-depth-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-depth-effect>
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                }]
        }], ctorParameters: () => [] });

class NgtpDepthOfField {
    constructor() {
        this.options = input({});
        this.effectComposer = inject(NgtpEffectComposer);
        this.effect = computed(() => {
            const [camera, options] = [this.effectComposer.camera(), this.options()];
            const autoFocus = options.target != null;
            const effect = new DepthOfFieldEffect(camera, options);
            // Creating a target enables autofocus, NGT will set via props
            if (autoFocus)
                effect.target = new THREE.Vector3();
            // Depth texture for depth picking with optional packing strategy
            if (options.depthTexture) {
                effect.setDepthTexture(options.depthTexture.texture, options.depthTexture.packing);
            }
            // Temporary fix that restores DOF 6.21.3 behavior, everything since then lets shapes leak through the blur
            const maskPass = effect['maskPass'];
            maskPass.maskFunction = MaskFunction.MULTIPLY_RGB_SET_ALPHA;
            return effect;
        });
        effect((onCleanup) => {
            const depthOfFieldEffect = this.effect();
            onCleanup(() => depthOfFieldEffect.dispose());
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpDepthOfField, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpDepthOfField, isStandalone: true, selector: "ngtp-depth-of-field", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, ngImport: i0, template: `
		<ngt-primitive *args="[effect()]" />
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpDepthOfField, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-depth-of-field',
                    template: `
		<ngt-primitive *args="[effect()]" />
	`,
                    imports: [NgtArgs],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                }]
        }], ctorParameters: () => [] });

class NgtpDotScreen {
    constructor() {
        this.options = input({});
        this.effect = inject(NgtpEffect, { host: true });
        extend({ DotScreenEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpDotScreen, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpDotScreen, isStandalone: true, selector: "ngtp-dot-screen", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-dot-screen-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-dot-screen-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpDotScreen, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-dot-screen',
                    template: `
		<ngt-dot-screen-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-dot-screen-effect>
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                }]
        }], ctorParameters: () => [] });

class NgtpFXAA {
    constructor() {
        this.options = input({});
        this.effect = inject(NgtpEffect, { host: true });
        extend({ FXAAEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpFXAA, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpFXAA, isStandalone: true, selector: "ngtp-fxaa", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-fXAA-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-fXAA-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpFXAA, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-fxaa',
                    template: `
		<ngt-fXAA-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-fXAA-effect>
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                }]
        }], ctorParameters: () => [] });

class NgtpGlitch {
    constructor() {
        this.options = input({ active: true }, { transform: mergeInputs({ active: true }) });
        this.active = pick(this.options, 'active');
        this.mode = pick(this.options, 'mode');
        this.ratio = pick(this.options, 'ratio');
        this.dtSize = pick(this.options, 'dtSize');
        this.columns = pick(this.options, 'columns');
        this.blendFunction = pick(this.options, 'blendFunction');
        this.perturbationMap = pick(this.options, 'perturbationMap');
        this.delay = vector2(this.options, 'delay');
        this.duration = vector2(this.options, 'duration');
        this.chromaticAberrationOffset = vector2(this.options, 'chromaticAberrationOffset');
        this.strength = vector2(this.options, 'strength');
        this.store = injectStore();
        this.effect = computed(() => new GlitchEffect({
            ratio: this.ratio(),
            dtSize: this.dtSize(),
            columns: this.columns(),
            blendFunction: this.blendFunction(),
            perturbationMap: this.perturbationMap(),
            delay: this.delay(),
            duration: this.duration(),
            chromaticAberrationOffset: this.chromaticAberrationOffset(),
            strength: this.strength(),
        }));
        effect(() => {
            const [glitchEffect, invalidate, mode, active] = [
                this.effect(),
                this.store.invalidate(),
                this.mode(),
                this.active(),
            ];
            glitchEffect.mode = active ? mode || GlitchMode.SPORADIC : GlitchMode.DISABLED;
            invalidate();
        });
        effect((onCleanup) => {
            const effect = this.effect();
            onCleanup(() => effect.dispose());
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpGlitch, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpGlitch, isStandalone: true, selector: "ngtp-glitch", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, ngImport: i0, template: `
		<ngt-primitive *args="[effect()]" />
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpGlitch, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-glitch',
                    template: `
		<ngt-primitive *args="[effect()]" />
	`,
                    imports: [NgtArgs],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                }]
        }], ctorParameters: () => [] });

class NgtpGodRays {
    constructor() {
        this.options = input({});
        this.effectComposer = inject(NgtpEffectComposer);
        this.effectOptions = omit(this.options, ['sun']);
        this.sun = pick(this.options, 'sun');
        this.sunElement = computed(() => {
            const sun = this.sun();
            if (typeof sun === 'function')
                return resolveRef(sun());
            return resolveRef(sun);
        });
        this.effect = computed(() => {
            const [camera, sunElement, options] = [this.effectComposer.camera(), this.sunElement(), this.effectOptions()];
            return new GodRaysEffect(camera, sunElement, options);
        });
        effect(() => {
            const sunElement = this.sunElement();
            if (!sunElement)
                return;
            const godRaysEffect = this.effect();
            godRaysEffect.lightSource = sunElement;
        });
        effect((onCleanup) => {
            const effect = this.effect();
            onCleanup(() => effect.dispose());
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpGodRays, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpGodRays, isStandalone: true, selector: "ngtp-god-rays", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, ngImport: i0, template: `
		<ngt-primitive *args="[effect()]" />
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpGodRays, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-god-rays',
                    template: `
		<ngt-primitive *args="[effect()]" />
	`,
                    imports: [NgtArgs],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                }]
        }], ctorParameters: () => [] });

class NgtpGrid {
    constructor() {
        this.options = input({});
        this.effectOptions = omit(this.options, ['size']);
        this.size = pick(this.options, 'size');
        this.effect = computed(() => new GridEffect(this.effectOptions()));
        effect(() => {
            const [size, effect] = [this.size(), this.effect()];
            if (size) {
                effect.setSize(size.width, size.height);
            }
        });
        effect((onCleanup) => {
            const effect = this.effect();
            onCleanup(() => effect.dispose());
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpGrid, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpGrid, isStandalone: true, selector: "ngtp-grid", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, ngImport: i0, template: `
		<ngt-primitive *args="[effect()]" />
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpGrid, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-grid',
                    template: `
		<ngt-primitive *args="[effect()]" />
	`,
                    imports: [NgtArgs],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                }]
        }], ctorParameters: () => [] });

class NgtpHueSaturation {
    constructor() {
        this.options = input({});
        this.effect = inject(NgtpEffect, { host: true });
        extend({ HueSaturationEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpHueSaturation, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpHueSaturation, isStandalone: true, selector: "ngtp-hue-saturation", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-hue-saturation-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-hue-saturation-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpHueSaturation, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-hue-saturation',
                    template: `
		<ngt-hue-saturation-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-hue-saturation-effect>
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                }]
        }], ctorParameters: () => [] });

// Created by Anderson Mancini 2023
// React Three Fiber Ultimate LensFlare
const LensFlareShader = {
    fragmentShader: /* language=glsl glsl */ `

  uniform float iTime;
  uniform vec2 lensPosition;
  uniform vec2 iResolution;
  uniform vec3 colorGain;
  uniform float starPoints;
  uniform float glareSize;
  uniform float flareSize;
  uniform float flareSpeed;
  uniform float flareShape;
  uniform float haloScale;
  uniform float opacity;
  uniform bool animated;
  uniform bool anamorphic;
  uniform bool enabled;
  uniform bool secondaryGhosts;
  uniform bool starBurst;
  uniform float ghostScale;
  uniform bool aditionalStreaks;
  uniform sampler2D lensDirtTexture;
  vec2 vxtC;

  float rndf(float n){return fract(sin(n) * 43758.5453123);}float niz(float p){float fl = floor(p);float fc = fract(p);return mix(rndf(fl),rndf(fl + 1.0), fc);}
  vec3 hsv2rgb(vec3 c){vec4 k = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);vec3 p = abs(fract(c.xxx + k.xyz) * 6.0 - k.www);return c.z * mix(k.xxx, clamp(p - k.xxx, 0.0, 1.0), c.y);}
  float satU(float x){return clamp(x, 0.,1.);}vec2 rtU(vec2 naz, float rtn){return vec2(cos(rtn) * naz.x + sin(rtn) * naz.y,cos(rtn) * naz.y - sin(rtn) * naz.x);}
  vec3 drwF(vec2 p, float intensity, float rnd, float speed, int id){float flhos = (1. / 32.) * float(id) * 0.1;float lingrad = distance(vec2(0.), p);float expg = 1. / exp(lingrad * (fract(rnd) * 0.66 + 0.33));vec3 qzTg = hsv2rgb(vec3( fract( (expg * 8.) + speed * flareSpeed + flhos), pow(1.-abs(expg*2.-1.), 0.45), 20.0 * expg * intensity));float internalStarPoints;if(anamorphic){internalStarPoints = 1.0;} else{internalStarPoints = starPoints;}float ams = length(p * flareShape * sin(internalStarPoints * atan(p.x, p.y)));float kJhg = pow(1.-satU(ams), ( anamorphic ? 100. : 12.));kJhg += satU(expg-0.9) * 3.;kJhg = pow(kJhg * expg, 8. + (1.-intensity) * 5.);if(flareSpeed > 0.0){return vec3(kJhg) * qzTg;} else{return vec3(kJhg) * flareSize * 15.;}}
  float ams2(vec3 a, vec3 b) { return abs(a.x - b.x) + abs(a.y - b.y) + abs(a.z - b.z);}vec3 satU(vec3 x){return clamp(x, vec3(0.0), vec3(1.0));}
  float glR(vec2 naz, vec2 pos, float zsi){vec2 mni;if(animated){mni = rtU(naz-pos, iTime * 0.1);} else{mni = naz-pos;}float ang = atan(mni.y, mni.x) * (anamorphic ? 1.0 : starPoints);float ams2 = length(mni);ams2 = pow(ams2, .9);float f0 = 1.0/(length(naz-pos)*(1.0/zsi*16.0)+.2);return f0+f0*(sin((ang))*.2 +.3);}
  float sdHex(vec2 p){p = abs(p);vec2 q = vec2(p.x*2.0*0.5773503, p.y + p.x*0.5773503);return dot(step(q.xy,q.yx), 1.0-q.yx);}float fpow(float x, float k){return x > k ? pow((x-k)/(1.0-k),2.0) : 0.0;}
  vec3 rHx(vec2 naz, vec2 p, float s, vec3 col){naz -= p;if (abs(naz.x) < 0.2*s && abs(naz.y) < 0.2*s){return mix(vec3(0),mix(vec3(0),col,0.1 + fpow(length(naz/s),0.1)*10.0),smoothstep(0.0,0.1,sdHex(naz*20.0/s)));}return vec3(0);}
  vec3 mLs(vec2 naz, vec2 pos){vec2 mni = naz-pos;vec2 zxMp = naz*(length(naz));float ang = atan(mni.x,mni.y);float f0 = .3/(length(naz-pos)*16.0+1.0);f0 = f0*(sin(niz(sin(ang*3.9-(animated ? iTime : 0.0) * 0.3) * starPoints))*.2 );float f1 = max(0.01-pow(length(naz+1.2*pos),1.9),.0)*7.0;float f2 = max(.9/(10.0+32.0*pow(length(zxMp+0.99*pos),2.0)),.0)*0.35;float f22 = max(.9/(11.0+32.0*pow(length(zxMp+0.85*pos),2.0)),.0)*0.23;float f23 = max(.9/(12.0+32.0*pow(length(zxMp+0.95*pos),2.0)),.0)*0.6;vec2 ztX = mix(naz,zxMp, 0.1);float f4 = max(0.01-pow(length(ztX+0.4*pos),2.9),.0)*4.02;float f42 = max(0.0-pow(length(ztX+0.45*pos),2.9),.0)*4.1;float f43 = max(0.01-pow(length(ztX+0.5*pos),2.9),.0)*4.6;ztX = mix(naz,zxMp,-.4);float f5 = max(0.01-pow(length(ztX+0.1*pos),5.5),.0)*2.0;float f52 = max(0.01-pow(length(ztX+0.2*pos),5.5),.0)*2.0;float f53 = max(0.01-pow(length(ztX+0.1*pos),5.5),.0)*2.0;ztX = mix(naz,zxMp, 2.1);float f6 = max(0.01-pow(length(ztX-0.3*pos),1.61),.0)*3.159;float f62 = max(0.01-pow(length(ztX-0.325*pos),1.614),.0)*3.14;float f63 = max(0.01-pow(length(ztX-0.389*pos),1.623),.0)*3.12;vec3 c = vec3(glR(naz,pos, glareSize));vec2 prot;if(animated){prot = rtU(naz - pos, (iTime * 0.1));} else if(anamorphic){prot = rtU(naz - pos, 1.570796);} else {prot = naz - pos;}c += drwF(prot, (anamorphic ? flareSize * 10. : flareSize), 0.1, iTime, 1);c.r+=f1+f2+f4+f5+f6; c.g+=f1+f22+f42+f52+f62; c.b+=f1+f23+f43+f53+f63;c = c*1.3 * vec3(length(zxMp)+.09);c+=vec3(f0);return c;}
  vec3 cc(vec3 clr, float fct,float fct2){float w = clr.x+clr.y+clr.z;return mix(clr,vec3(w)*fct,w*fct2);}float rnd(vec2 p){float f = fract(sin(dot(p, vec2(12.1234, 72.8392) )*45123.2));return f;}float rnd(float w){float f = fract(sin(w)*1000.);return f;}
  float rShp(vec2 p, int N){float f;float a=atan(p.x,p.y)+.2;float b=6.28319/float(N);f=smoothstep(.5,.51, cos(floor(.5+a/b)*b-a)*length(p.xy)* 2.0  -ghostScale);return f;}
  vec3 drC(vec2 p, float zsi, float dCy, vec3 clr, vec3 clr2, float ams2, vec2 esom){float l = length(p + esom*(ams2*2.))+zsi/2.;float l2 = length(p + esom*(ams2*4.))+zsi/3.;float c = max(0.01-pow(length(p + esom*ams2), zsi*ghostScale), 0.0)*10.;float c1 = max(0.001-pow(l-0.3, 1./40.)+sin(l*20.), 0.0)*3.;float c2 =  max(0.09/pow(length(p-esom*ams2/.5)*1., .95), 0.0)/20.;float s = max(0.02-pow(rShp(p*5. + esom*ams2*5. + dCy, 6) , 1.), 0.0)*1.5;clr = cos(vec3(0.44, .24, .2)*8. + ams2*4.)*0.5+.5;vec3 f = c*clr;f += c1*clr;f += c2*clr;f +=  s*clr;return f-0.01;}
  vec4 geLC(float x){return vec4(vec3(mix(mix(mix(mix(mix(mix(mix(mix(mix(mix(mix(mix(mix(mix(mix(vec3(0., 0., 0.),vec3(0., 0., 0.), smoothstep(0.0, 0.063, x)),vec3(0., 0., 0.), smoothstep(0.063, 0.125, x)),vec3(0.0, 0., 0.), smoothstep(0.125, 0.188, x)),vec3(0.188, 0.131, 0.116), smoothstep(0.188, 0.227, x)),vec3(0.31, 0.204, 0.537), smoothstep(0.227, 0.251, x)),vec3(0.192, 0.106, 0.286), smoothstep(0.251, 0.314, x)),vec3(0.102, 0.008, 0.341), smoothstep(0.314, 0.392, x)),vec3(0.086, 0.0, 0.141), smoothstep(0.392, 0.502, x)),vec3(1.0, 0.31, 0.0), smoothstep(0.502, 0.604, x)),vec3(.1, 0.1, 0.1), smoothstep(0.604, 0.643, x)),vec3(1.0, 0.929, 0.0), smoothstep(0.643, 0.761, x)),vec3(1.0, 0.086, 0.424), smoothstep(0.761, 0.847, x)),vec3(1.0, 0.49, 0.0), smoothstep(0.847, 0.89, x)),vec3(0.945, 0.275, 0.475), smoothstep(0.89, 0.941, x)),vec3(0.251, 0.275, 0.796), smoothstep(0.941, 1.0, x))),1.0);}
  float diTN(vec2 p){vec2 f = fract(p);f = (f * f) * (3.0 - (2.0 * f));float n = dot(floor(p), vec2(1.0, 157.0));vec4 a = fract(sin(vec4(n + 0.0, n + 1.0, n + 157.0, n + 158.0)) * 43758.5453123);return mix(mix(a.x, a.y, f.x), mix(a.z, a.w, f.x), f.y);}
  float fbm(vec2 p){const mat2 m = mat2(0.80, -0.60, 0.60, 0.80);float f = 0.0;f += 0.5000*diTN(p); p = m*p*2.02;f += 0.2500*diTN(p); p = m*p*2.03;f += 0.1250*diTN(p); p = m*p*2.01;f += 0.0625*diTN(p);return f/0.9375;}
  vec4 geLS(vec2 p){vec2 pp = (p - vec2(0.5)) * 2.0;float a = atan(pp.y, pp.x);vec4 cp = vec4(sin(a * 1.0), length(pp), sin(a * 13.0), sin(a * 53.0));float d = sin(clamp(pow(length(vec2(0.5) - p) * 0.5 + haloScale /2., 5.0), 0.0, 1.0) * 3.14159);vec3 c = vec3(d) * vec3(fbm(cp.xy * 16.0) * fbm(cp.zw * 9.0) * max(max(max(max(0.5, sin(a * 1.0)), sin(a * 3.0) * 0.8), sin(a * 7.0) * 0.8), sin(a * 9.0) * 10.6));c *= vec3(mix(2.0, (sin(length(pp.xy) * 256.0) * 0.5) + 0.5, sin((clamp((length(pp.xy) - 0.875) / 0.1, 0.0, 1.0) + 0.0) * 2.0 * 3.14159) * 1.5) + 0.5) * 0.3275;return vec4(vec3(c * 1.0), d);}
  vec4 geLD(vec2 p){p.xy += vec2(fbm(p.yx * 3.0), fbm(p.yx * 2.0)) * 0.0825;vec3 o = vec3(mix(0.125, 0.25, max(max(smoothstep(0.1, 0.0, length(p - vec2(0.25))),smoothstep(0.4, 0.0, length(p - vec2(0.75)))),smoothstep(0.8, 0.0, length(p - vec2(0.875, 0.125))))));o += vec3(max(fbm(p * 1.0) - 0.5, 0.0)) * 0.5;o += vec3(max(fbm(p * 2.0) - 0.5, 0.0)) * 0.5;o += vec3(max(fbm(p * 4.0) - 0.5, 0.0)) * 0.25;o += vec3(max(fbm(p * 8.0) - 0.75, 0.0)) * 1.0;o += vec3(max(fbm(p * 16.0) - 0.75, 0.0)) * 0.75;o += vec3(max(fbm(p * 64.0) - 0.75, 0.0)) * 0.5;return vec4(clamp(o, vec3(0.15), vec3(1.0)), 1.0);}
  vec4 txL(sampler2D tex, vec2 xtC){if(((xtC.x < 0.) || (xtC.y < 0.)) || ((xtC.x > 1.) || (xtC.y > 1.))){return vec4(0.0);}else{return texture(tex, xtC); }}
  vec4 txD(sampler2D tex, vec2 xtC, vec2 dir, vec3 ditn) {return vec4(txL(tex, (xtC + (dir * ditn.r))).r,txL(tex, (xtC + (dir * ditn.g))).g,txL(tex, (xtC + (dir * ditn.b))).b,1.0);}
  vec4 strB(){vec2 aspXtc = vec2(1.0) - (((vxtC - vec2(0.5)) * vec2(1.0)) + vec2(0.5)); vec2 xtC = vec2(1.0) - vxtC; vec2 ghvc = (vec2(0.5) - xtC) * 0.3 - lensPosition; vec2 ghNm = normalize(ghvc * vec2(1.0)) * vec2(1.0);vec2 haloVec = normalize(ghvc) * 0.6;vec2 hlNm = ghNm * 0.6;vec2 texelSize = vec2(1.0) / vec2(iResolution.xy);vec3 ditn = vec3(-(texelSize.x * 1.5), 0.2, texelSize.x * 1.5);vec4 c = vec4(0.0);for (int i = 0; i < 8; i++) {vec2 offset = xtC + (ghvc * float(i));c += txD(lensDirtTexture, offset, ghNm, ditn) * pow(max(0.0, 1.0 - (length(vec2(0.5) - offset) / length(vec2(0.5)))), 10.0);}vec2 uyTrz = xtC + hlNm; return (c * geLC((length(vec2(0.5) - aspXtc) / length(vec2(haloScale))))) +(txD(lensDirtTexture, uyTrz, ghNm, ditn) * pow(max(0.0, 1.0 - (length(vec2(0.5) - uyTrz) / length(vec2(0.5)))), 10.0));}
  void mainImage(vec4 v,vec2 r,out vec4 i){vec2 g=r-.5;g.y*=iResolution.y/iResolution.x;vec2 l=lensPosition*.5;l.y*=iResolution.y/iResolution.x;vec3 f=mLs(g,l)*20.*colorGain/256.;if(aditionalStreaks){vec3 o=vec3(.9,.2,.1),p=vec3(.3,.1,.9);for(float n=0.;n<10.;n++)f+=drC(g,pow(rnd(n*2e3)*2.8,.1)+1.41,0.,o+n,p+n,rnd(n*20.)*3.+.2-.5,lensPosition);}if(secondaryGhosts){vec3 n=vec3(0);n+=rHx(g,-lensPosition*.25,ghostScale*1.4,vec3(.25,.35,0));n+=rHx(g,lensPosition*.25,ghostScale*.5,vec3(1,.5,.5));n+=rHx(g,lensPosition*.1,ghostScale*1.6,vec3(1));n+=rHx(g,lensPosition*1.8,ghostScale*2.,vec3(0,.5,.75));n+=rHx(g,lensPosition*1.25,ghostScale*.8,vec3(1,1,.5));n+=rHx(g,-lensPosition*1.25,ghostScale*5.,vec3(.5,.5,.25));n+=fpow(1.-abs(distance(lensPosition*.8,g)-.7),.985)*colorGain/2100.;f+=n;}if(starBurst){vxtC=g+.5;vec4 n=geLD(g);float o=1.-clamp(0.5,0.,.5)*2.;n+=mix(n,pow(n*2.,vec4(2))*.5,o);float s=(g.x+g.y)*(1./6.);vec2 d=mat2(cos(s),-sin(s),sin(s),cos(s))*vxtC;n+=geLS(d)*2.;f+=clamp(n.xyz*strB().xyz,.01,1.);}i=enabled?vec4(mix(f,vec3(0),opacity)+v.xyz,v.w):vec4(v);}
`,
};
class LensFlareEffect extends Effect {
    constructor({ blendFunction = BlendFunction.NORMAL, enabled = true, glareSize = 0.2, lensPosition = [0.01, 0.01], iResolution = [0, 0], starPoints = 6, flareSize = 0.01, flareSpeed = 0.01, flareShape = 0.01, animated = true, anamorphic = false, colorGain = new THREE.Color(20, 20, 20), lensDirtTexture = null, haloScale = 0.5, secondaryGhosts = true, aditionalStreaks = true, ghostScale = 0.0, opacity = 1.0, starBurst = false, } = {}) {
        super('LensFlareEffect', LensFlareShader.fragmentShader, {
            blendFunction,
            uniforms: new Map([
                ['enabled', new THREE.Uniform(enabled)],
                ['glareSize', new THREE.Uniform(glareSize)],
                ['lensPosition', new THREE.Uniform(lensPosition)],
                ['iTime', new THREE.Uniform(0)],
                ['iResolution', new THREE.Uniform(iResolution)],
                ['starPoints', new THREE.Uniform(starPoints)],
                ['flareSize', new THREE.Uniform(flareSize)],
                ['flareSpeed', new THREE.Uniform(flareSpeed)],
                ['flareShape', new THREE.Uniform(flareShape)],
                ['animated', new THREE.Uniform(animated)],
                ['anamorphic', new THREE.Uniform(anamorphic)],
                ['colorGain', new THREE.Uniform(colorGain)],
                ['lensDirtTexture', new THREE.Uniform(lensDirtTexture)],
                ['haloScale', new THREE.Uniform(haloScale)],
                ['secondaryGhosts', new THREE.Uniform(secondaryGhosts)],
                ['aditionalStreaks', new THREE.Uniform(aditionalStreaks)],
                ['ghostScale', new THREE.Uniform(ghostScale)],
                ['starBurst', new THREE.Uniform(starBurst)],
                ['opacity', new THREE.Uniform(opacity)],
            ]),
        });
    }
    update(_renderer, _inputBuffer, deltaTime) {
        const iTime = this.uniforms.get('iTime');
        if (iTime) {
            iTime.value += deltaTime;
        }
    }
}
const defaultOptions$3 = {
    position: new THREE.Vector3(-25, 6, -60),
    followMouse: false,
    smoothTime: 0.7,
};
class NgtpLensFlare {
    constructor() {
        this.options = input(defaultOptions$3, { transform: mergeInputs(defaultOptions$3) });
        this.store = injectStore();
        this.effectComposer = inject(NgtpEffectComposer);
        this.effectOptions = omit(this.options, ['position', 'followMouse', 'smoothTime']);
        this.position = vector3(this.options, 'position');
        this.projectedPosition = new THREE.Vector3();
        this.mouse2d = new THREE.Vector2();
        this.effect = computed(() => new LensFlareEffect(this.effectOptions()));
        effect(() => {
            const [lensFlareEffect, width, height] = [
                this.effect(),
                this.store.viewport.width(),
                this.store.viewport.height(),
            ];
            const iResolution = lensFlareEffect.uniforms.get('iResolution');
            if (iResolution) {
                iResolution.value.x = width;
                iResolution.value.y = height;
            }
        });
        effect((onCleanup) => {
            const effect = this.effect();
            onCleanup(() => effect.dispose());
        });
        injectBeforeRender(({ delta }) => {
            const [effect] = [this.effect()];
            if (!effect)
                return;
            const [{ followMouse, smoothTime }, position, pointer, camera, scene, raycaster] = [
                this.options(),
                this.position(),
                this.store.snapshot.pointer,
                this.effectComposer.camera(),
                this.effectComposer.scene(),
                this.store.snapshot.raycaster,
            ];
            const uLensPosition = effect.uniforms.get('lensPosition');
            const uOpacity = effect.uniforms.get('opacity');
            if (!uLensPosition || !uOpacity)
                return;
            let target = 1;
            if (followMouse) {
                uLensPosition.value.x = pointer.x;
                uLensPosition.value.y = pointer.y;
                target = 0;
            }
            else {
                this.projectedPosition.copy(position).project(camera);
                if (this.projectedPosition.z > 1)
                    return;
                uLensPosition.value.x = this.projectedPosition.x;
                uLensPosition.value.y = this.projectedPosition.y;
                this.mouse2d.set(this.projectedPosition.x, this.projectedPosition.y);
                raycaster.setFromCamera(this.mouse2d, camera);
                const intersects = raycaster.intersectObjects(scene.children, true);
                const { object } = intersects[0] ?? {};
                if (object) {
                    if (object.userData?.['lensflare'] === 'no-occlusion') {
                        target = 0;
                    }
                    else if (is.three(object, 'isMesh')) {
                        if (object.material.uniforms?.['_transmission']?.value > 0.2) {
                            //Check for MeshTransmissionMaterial
                            target = 0.2;
                        }
                        else if ('_transmission' in object.material &&
                            typeof object.material._transmission === 'number' &&
                            object.material._transmission > 0.2) {
                            //Check for MeshPhysicalMaterial with transmission setting
                            target = 0.2;
                        }
                        else if (object.material.transparent) {
                            // Check for OtherMaterials with transparent parameter
                            target = object.material.opacity;
                        }
                    }
                }
            }
            easing.damp(uOpacity, 'value', target, smoothTime, delta);
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpLensFlare, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpLensFlare, isStandalone: true, selector: "ngtp-lens-flare", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, ngImport: i0, template: `
		<ngt-primitive *args="[effect()]" [parameters]="{ dispose: null }" />
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpLensFlare, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-lens-flare',
                    template: `
		<ngt-primitive *args="[effect()]" [parameters]="{ dispose: null }" />
	`,
                    imports: [NgtArgs],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                }]
        }], ctorParameters: () => [] });

class NgtpLUT {
    constructor() {
        this.options = input({});
        this.lut = pick(this.options, 'lut');
        this.tetrahedralInterpolation = pick(this.options, 'tetrahedralInterpolation');
        this.store = injectStore();
        this.effect = computed(() => {
            const { lut, ...options } = this.options();
            return new LUT3DEffect(lut, options);
        });
        effect(() => {
            const [effect, lut, tetrahedralInterpolation, invalidate] = [
                this.effect(),
                this.lut(),
                this.tetrahedralInterpolation(),
                this.store.invalidate(),
            ];
            if (tetrahedralInterpolation)
                effect.tetrahedralInterpolation = tetrahedralInterpolation;
            if (lut)
                effect.lut = lut;
            invalidate();
        });
        effect((onCleanup) => {
            const effect = this.effect();
            onCleanup(() => effect.dispose());
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpLUT, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpLUT, isStandalone: true, selector: "ngtp-lut", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, ngImport: i0, template: `
		<ngt-primitive *args="[effect()]" [dispose]="null" />
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpLUT, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-lut',
                    template: `
		<ngt-primitive *args="[effect()]" [dispose]="null" />
	`,
                    imports: [NgtArgs],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                }]
        }], ctorParameters: () => [] });

class NgtpNoise {
    constructor() {
        this.options = input({});
        this.effect = inject(NgtpEffect, { host: true });
        extend({ NoiseEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpNoise, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpNoise, isStandalone: true, selector: "ngtp-noise", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, providers: [provideDefaultEffectOptions({ blendFunction: BlendFunction.COLOR_DODGE })], hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-noise-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-noise-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpNoise, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-noise',
                    template: `
		<ngt-noise-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-noise-effect>
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                    providers: [provideDefaultEffectOptions({ blendFunction: BlendFunction.COLOR_DODGE })],
                }]
        }], ctorParameters: () => [] });

const defaultOptions$2 = {
    selectionLayer: 10,
};
class NgtpOutline {
    constructor() {
        this.options = input(defaultOptions$2, { transform: mergeInputs(defaultOptions$2) });
        this.ngtSelection = inject(NgtSelection, { optional: true });
        this.effectComposer = inject(NgtpEffectComposer);
        this.store = injectStore();
        this.selection = pick(this.options, 'selection');
        this.selectionLayer = pick(this.options, 'selectionLayer');
        this.blendFunction = pick(this.options, 'blendFunction');
        this.patternTexture = pick(this.options, 'patternTexture');
        this.edgeStrength = pick(this.options, 'edgeStrength');
        this.pulseSpeed = pick(this.options, 'pulseSpeed');
        this.visibleEdgeColor = pick(this.options, 'visibleEdgeColor');
        this.hiddenEdgeColor = pick(this.options, 'hiddenEdgeColor');
        this.width = pick(this.options, 'width');
        this.height = pick(this.options, 'height');
        this.kernelSize = pick(this.options, 'kernelSize');
        this.blur = pick(this.options, 'blur');
        this.xRay = pick(this.options, 'xRay');
        this.restOptions = omit(this.options, [
            'blendFunction',
            'patternTexture',
            'edgeStrength',
            'pulseSpeed',
            'visibleEdgeColor',
            'hiddenEdgeColor',
            'width',
            'height',
            'kernelSize',
            'blur',
            'xRay',
        ]);
        this.effect = computed(() => {
            const [scene, camera, blendFunction, patternTexture, edgeStrength, pulseSpeed, visibleEdgeColor, hiddenEdgeColor, width, height, kernelSize, blur, xRay, restOptions,] = [
                this.effectComposer.scene(),
                this.effectComposer.camera(),
                this.blendFunction(),
                this.patternTexture(),
                this.edgeStrength(),
                this.pulseSpeed(),
                this.visibleEdgeColor(),
                this.hiddenEdgeColor(),
                this.width(),
                this.height(),
                this.kernelSize(),
                this.blur(),
                this.xRay(),
                untracked(this.restOptions),
            ];
            return new OutlineEffect(scene, camera, {
                blendFunction,
                patternTexture,
                edgeStrength,
                pulseSpeed,
                visibleEdgeColor,
                hiddenEdgeColor,
                width,
                height,
                kernelSize,
                blur,
                xRay,
                ...restOptions,
            });
        });
        effect((onCleanup) => {
            const effect = this.effect();
            onCleanup(() => effect.dispose());
        });
        effect(() => {
            const [effect, invalidate, selectionLayer] = [
                this.effect(),
                this.store.invalidate(),
                this.selectionLayer(),
            ];
            effect.selectionLayer = selectionLayer;
            invalidate();
        });
        effect((onCleanup) => {
            // NOTE: we run this effect if declarative NgtSelection is not enabled
            if (!this.ngtSelection) {
                // NOTE: if NgtSelection is not used and selection is not provided, we throw
                if (this.selection() === undefined) {
                    throw new Error('[NGT PostProcessing]: ngtp-outline requires selection input or use NgtSelection');
                }
                const cleanup = this.handleSelectionChangeEffect(this.selection, this.effect, this.store.invalidate);
                onCleanup(() => {
                    cleanup?.();
                });
                return;
            }
            // NOTE: we run this effect if declarative NgtSelection is enabled
            const selectionEnabled = this.ngtSelection.enabled();
            if (!selectionEnabled)
                return;
            const cleanup = this.handleSelectionChangeEffect(this.ngtSelection.selected, this.effect, this.store.invalidate);
            onCleanup(() => {
                cleanup?.();
            });
        });
    }
    handleSelectionChangeEffect(selected, _effect, _invalidate) {
        const selection = selected();
        if (!selection || selection.length === 0)
            return;
        const [effect, invalidate] = [_effect(), _invalidate()];
        const objects = [];
        for (const el of selection) {
            const obj = resolveRef(el);
            if (!obj)
                continue;
            objects.push(obj);
        }
        if (objects.length === 0)
            return;
        effect.selection.set(objects);
        invalidate();
        return () => {
            effect.selection.clear();
            invalidate();
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpOutline, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpOutline, isStandalone: true, selector: "ngtp-outline", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, ngImport: i0, template: `
		<ngt-primitive *args="[effect()]" />
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpOutline, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-outline',
                    template: `
		<ngt-primitive *args="[effect()]" />
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [NgtArgs],
                }]
        }], ctorParameters: () => [] });

class NgtpPixelation {
    constructor() {
        this.options = input({ granularity: 5 }, { transform: mergeInputs({ granularity: 5 }) });
        this.granularity = pick(this.options, 'granularity');
        this.effect = computed(() => new PixelationEffect(this.granularity()));
        effect((onCleanup) => {
            const effect = this.effect();
            onCleanup(() => effect.dispose());
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpPixelation, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpPixelation, isStandalone: true, selector: "ngtp-pixelation", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, ngImport: i0, template: `
		<ngt-primitive *args="[effect()]" />
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpPixelation, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-pixelation',
                    template: `
		<ngt-primitive *args="[effect()]" />
	`,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    imports: [NgtArgs],
                }]
        }], ctorParameters: () => [] });

const defaultOptions$1 = {
    density: 1.25,
};
class NgtpScanline {
    constructor() {
        this.options = input(defaultOptions$1, { transform: mergeInputs(defaultOptions$1) });
        this.effect = inject(NgtpEffect, { host: true });
        extend({ ScanlineEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpScanline, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpScanline, isStandalone: true, selector: "ngtp-scanline", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, providers: [provideDefaultEffectOptions({ blendFunction: BlendFunction.OVERLAY })], hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-scanline-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-scanline-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpScanline, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-scanline',
                    template: `
		<ngt-scanline-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-scanline-effect>
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                    providers: [provideDefaultEffectOptions({ blendFunction: BlendFunction.OVERLAY })],
                }]
        }], ctorParameters: () => [] });

// const addLight = (light: Object3D, effect: SelectiveBloomEffect) => light.layers.enable(effect.selection.layer)
// const removeLight = (light: Object3D, effect: SelectiveBloomEffect) => light.layers.disable(effect.selection.layer)
const defaultOptions = {
    selectionLayer: 10,
    inverted: false,
    ignoreBackground: false,
};
class NgtpSelectiveBloom {
    constructor() {
        this.lights = input.required();
        this.selection = input([]);
        this.options = input(defaultOptions, { transform: mergeInputs(defaultOptions) });
        this.blendFunction = pick(this.options, 'blendFunction');
        this.luminanceThreshold = pick(this.options, 'luminanceThreshold');
        this.luminanceSmoothing = pick(this.options, 'luminanceSmoothing');
        this.mipmapBlur = pick(this.options, 'mipmapBlur');
        this.intensity = pick(this.options, 'intensity');
        this.radius = pick(this.options, 'radius');
        this.levels = pick(this.options, 'levels');
        this.kernelSize = pick(this.options, 'kernelSize');
        this.resolutionScale = pick(this.options, 'resolutionScale');
        this.width = pick(this.options, 'width');
        this.height = pick(this.options, 'height');
        this.resolutionX = pick(this.options, 'resolutionX');
        this.resolutionY = pick(this.options, 'resolutionY');
        this.inverted = pick(this.options, 'inverted');
        this.ignoreBackground = pick(this.options, 'ignoreBackground');
        this.selectionLayer = pick(this.options, 'selectionLayer');
        this.store = injectStore();
        this.effectComposer = inject(NgtpEffectComposer);
        this.ngtSelection = inject(NgtSelection, { optional: true });
        this.resolvedLights = computed(() => this.lights().map((light) => resolveRef(light)));
        this.resolvedSelected = computed(() => {
            const selection = this.selection();
            if (!selection)
                return [];
            const array = Array.isArray(selection) ? selection : [selection];
            return array.map((selected) => resolveRef(selected));
        });
        this.resolvedNgtSelected = computed(() => {
            if (!this.ngtSelection || !this.ngtSelection.enabled)
                return [];
            return this.ngtSelection.selected().map((selected) => resolveRef(selected));
        });
        this.effect = computed(() => {
            const effect = new SelectiveBloomEffect(this.effectComposer.scene(), this.effectComposer.camera(), {
                blendFunction: this.blendFunction() || BlendFunction.ADD,
                luminanceThreshold: this.luminanceThreshold(),
                luminanceSmoothing: this.luminanceSmoothing(),
                mipmapBlur: this.mipmapBlur(),
                intensity: this.intensity(),
                radius: this.radius(),
                levels: this.levels(),
                kernelSize: this.kernelSize(),
                resolutionScale: this.resolutionScale(),
                width: this.width(),
                height: this.height(),
                resolutionX: this.resolutionX(),
                resolutionY: this.resolutionY(),
            });
            effect.inverted = this.inverted();
            effect.ignoreBackground = this.ignoreBackground();
            return effect;
        });
        effect((onCleanup) => {
            // skip input selection altogether if NgtSelection is used
            if (this.ngtSelection)
                return;
            const selection = this.resolvedSelected();
            if (!selection.length)
                return;
            const [effect, invalidate] = [this.effect(), this.store.invalidate(), this.selectionLayer()];
            effect.selection.set(selection);
            invalidate();
            onCleanup(() => {
                effect.selection.clear();
                invalidate();
            });
        });
        effect(() => {
            const [selectionLayer, invalidate, effect] = [
                this.selectionLayer(),
                this.store.invalidate(),
                this.effect(),
            ];
            effect.selection.layer = selectionLayer;
            invalidate();
        });
        effect((onCleanup) => {
            const lights = this.resolvedLights();
            if (lights.length <= 0)
                return;
            const [effect, invalidate] = [this.effect(), this.store.invalidate(), this.selectionLayer()];
            lights.forEach((light) => light && this.addLight(effect, light));
            invalidate();
            onCleanup(() => {
                lights.forEach((light) => light && this.removeLight(effect, light));
                invalidate();
            });
        });
        effect((onCleanup) => {
            const selected = this.resolvedNgtSelected();
            if (!selected.length)
                return;
            const [effect, invalidate] = [this.effect(), this.store.invalidate(), this.selectionLayer()];
            effect.selection.set(selected);
            invalidate();
            onCleanup(() => {
                effect.selection.clear();
                invalidate();
            });
        });
    }
    addLight(effect, light) {
        light.layers.enable(effect.selection.layer);
    }
    removeLight(effect, light) {
        light.layers.disable(effect.selection.layer);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpSelectiveBloom, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpSelectiveBloom, isStandalone: true, selector: "ngtp-selective-bloom", inputs: { lights: { classPropertyName: "lights", publicName: "lights", isSignal: true, isRequired: true, transformFunction: null }, selection: { classPropertyName: "selection", publicName: "selection", isSignal: true, isRequired: false, transformFunction: null }, options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, ngImport: i0, template: `
		<ngt-primitive *args="[effect()]" [dispose]="null" />
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpSelectiveBloom, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-selective-bloom',
                    template: `
		<ngt-primitive *args="[effect()]" [dispose]="null" />
	`,
                    imports: [NgtArgs],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                }]
        }], ctorParameters: () => [] });

class NgtpSepia {
    constructor() {
        this.options = input({});
        this.effect = inject(NgtpEffect, { host: true });
        extend({ SepiaEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpSepia, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpSepia, isStandalone: true, selector: "ngtp-sepia", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-sepia-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-sepia-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpSepia, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-sepia',
                    template: `
		<ngt-sepia-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-sepia-effect>
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                }]
        }], ctorParameters: () => [] });

class NgtpShockWave {
    constructor() {
        this.options = input({});
        this.effect = inject(NgtpEffect, { host: true });
        extend({ ShockWaveEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpShockWave, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpShockWave, isStandalone: true, selector: "ngtp-shock-wave", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-shock-wave-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-shock-wave-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpShockWave, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-shock-wave',
                    template: `
		<ngt-shock-wave-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-shock-wave-effect>
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                }]
        }], ctorParameters: () => [] });

class NgtpSMAA {
    constructor() {
        this.options = input({});
        this.effect = inject(NgtpEffect, { host: true });
        extend({ SMAAEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpSMAA, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpSMAA, isStandalone: true, selector: "ngtp-smaa", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-sMAA-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-sMAA-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpSMAA, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-smaa',
                    template: `
		<ngt-sMAA-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-sMAA-effect>
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                }]
        }], ctorParameters: () => [] });

class NgtpTiltShift {
    constructor() {
        this.options = input({});
        this.effect = inject(NgtpEffect, { host: true });
        extend({ TiltShiftEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpTiltShift, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpTiltShift, isStandalone: true, selector: "ngtp-tilt-shift", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, providers: [provideDefaultEffectOptions({ blendFunction: BlendFunction.ADD })], hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-tilt-shift-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-tilt-shift-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpTiltShift, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-tilt-shift',
                    template: `
		<ngt-tilt-shift-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-tilt-shift-effect>
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                    providers: [provideDefaultEffectOptions({ blendFunction: BlendFunction.ADD })],
                }]
        }], ctorParameters: () => [] });

const TiltShiftShader = {
    fragmentShader: /* language=glsl glsl */ `

    // original shader by Evan Wallace

    #define MAX_ITERATIONS 100

    uniform float blur;
    uniform float taper;
    uniform vec2 start;
    uniform vec2 end;
    uniform vec2 direction;
    uniform int samples;

    float random(vec3 scale, float seed) {
        /* use the fragment position for a different seed per-pixel */
        return fract(sin(dot(gl_FragCoord.xyz + seed, scale)) * 43758.5453 + seed);
    }

    void mainImage(const in vec4 inputColor, const in vec2 uv, out vec4 outputColor) {
        vec4 color = vec4(0.0);
        float total = 0.0;
        vec2 startPixel = vec2(start.x * resolution.x, start.y * resolution.y);
        vec2 endPixel = vec2(end.x * resolution.x, end.y * resolution.y);
        float f_samples = float(samples);
        float half_samples = f_samples / 2.0;

        // use screen diagonal to normalize blur radii
        float maxScreenDistance = distance(vec2(0.0), resolution); // diagonal distance
        float gradientRadius = taper * (maxScreenDistance);
        float blurRadius = blur * (maxScreenDistance / 16.0);

        /* randomize the lookup values to hide the fixed number of samples */
        float offset = random(vec3(12.9898, 78.233, 151.7182), 0.0);
        vec2 normal = normalize(vec2(startPixel.y - endPixel.y, endPixel.x - startPixel.x));
        float radius = smoothstep(0.0, 1.0, abs(dot(uv * resolution - startPixel, normal)) / gradientRadius) * blurRadius;

        #pragma unroll_loop_start
        for (int i = 0; i <= MAX_ITERATIONS; i++) {
            if (i >= samples) { break; } // return early if over sample count
            float f_i = float(i);
            float s_i = -half_samples + f_i;
            float percent = (s_i + offset - 0.5) / half_samples;
            float weight = 1.0 - abs(percent);
            vec4 sample_i = texture2D(inputBuffer, uv + normalize(direction) / resolution * percent * radius);
            /* switch to pre-multiplied alpha to correctly blur transparent images */
            sample_i.rgb *= sample_i.a;
            color += sample_i * weight;
            total += weight;
        }
        #pragma unroll_loop_end

        outputColor = color / total;

        /* switch back from pre-multiplied alpha */
        outputColor.rgb /= outputColor.a + 0.00001;
    }
    `,
};
class TiltShift2Effect extends Effect {
    constructor({ blendFunction = BlendFunction.NORMAL, blur = 0.15, // [0, 1], can go beyond 1 for extra
    taper = 0.5, // [0, 1], can go beyond 1 for extra
    start = [0.5, 0.0], // [0,1] percentage x,y of screenspace
    end = [0.5, 1.0], // [0,1] percentage x,y of screenspace
    samples = 10.0, // number of blur samples
    direction = [1, 1], // direction of blur
     } = {}) {
        super('TiltShiftEffect', TiltShiftShader.fragmentShader, {
            blendFunction,
            attributes: EffectAttribute.CONVOLUTION,
            uniforms: new Map([
                ['blur', new THREE.Uniform(blur)],
                ['taper', new THREE.Uniform(taper)],
                ['start', new THREE.Uniform(start)],
                ['end', new THREE.Uniform(end)],
                ['samples', new THREE.Uniform(samples)],
                ['direction', new THREE.Uniform(direction)],
            ]),
        });
    }
}
extend({ TiltShift2Effect });
class NgtpTiltShift2 {
    constructor() {
        this.options = input({});
        this.effect = inject(NgtpEffect, { host: true });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpTiltShift2, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpTiltShift2, isStandalone: true, selector: "ngtp-tilt-shift2", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, providers: [provideDefaultEffectOptions({ blendFunction: BlendFunction.NORMAL })], hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-tilt-shift2-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-tilt-shift2-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpTiltShift2, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-tilt-shift2',
                    template: `
		<ngt-tilt-shift2-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-tilt-shift2-effect>
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                    providers: [provideDefaultEffectOptions({ blendFunction: BlendFunction.NORMAL })],
                }]
        }] });

class NgtpToneMapping {
    constructor() {
        this.options = input({});
        this.effect = inject(NgtpEffect, { host: true });
        extend({ ToneMappingEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpToneMapping, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpToneMapping, isStandalone: true, selector: "ngtp-tone-mapping", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-tone-mapping-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-tone-mapping-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpToneMapping, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-tone-mapping',
                    template: `
		<ngt-tone-mapping-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-tone-mapping-effect>
	`,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                }]
        }], ctorParameters: () => [] });

class NgtpVignette {
    constructor() {
        this.options = input({});
        this.effect = inject(NgtpEffect, { host: true });
        extend({ VignetteEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpVignette, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpVignette, isStandalone: true, selector: "ngtp-vignette", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-vignette-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-vignette-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpVignette, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-vignette',
                    template: `
		<ngt-vignette-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-vignette-effect>
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                }]
        }], ctorParameters: () => [] });

const WaterShader = {
    fragmentShader: /* language=glsl glsl */ `
  uniform float factor;
  void mainImage(const in vec4 inputColor, const in vec2 uv, out vec4 outputColor) {
    vec2 vUv = uv;
    float frequency = 6.0 * factor;
    float amplitude = 0.015 * factor;
    float x = vUv.y * frequency + time * .7;
    float y = vUv.x * frequency + time * .3;
    vUv.x += cos(x+y) * amplitude * cos(y);
    vUv.y += sin(x-y) * amplitude * cos(y);
    vec4 rgba = texture2D(inputBuffer, vUv);
    outputColor = rgba;
  }`,
};
class WaterEffect extends Effect {
    constructor({ blendFunction = BlendFunction.NORMAL, factor = 0 } = {}) {
        super('WaterEffect', WaterShader.fragmentShader, {
            blendFunction,
            attributes: EffectAttribute.CONVOLUTION,
            uniforms: new Map([['factor', new THREE.Uniform(factor)]]),
        });
    }
}
class NgtpWater {
    constructor() {
        this.options = input({});
        this.effect = inject(NgtpEffect, { host: true });
        extend({ WaterEffect });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpWater, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.1.5", type: NgtpWater, isStandalone: true, selector: "ngtp-water", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: false, transformFunction: null } }, providers: [provideDefaultEffectOptions({ blendFunction: BlendFunction.NORMAL })], hostDirectives: [{ directive: NgtpEffect, inputs: ["blendFunction", "blendFunction", "opacity", "opacity"] }], ngImport: i0, template: `
		<ngt-water-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-water-effect>
	`, isInline: true, dependencies: [{ kind: "directive", type: NgtArgs, selector: "ng-template[args]", inputs: ["args"] }, { kind: "component", type: NgtpEffectBlendMode, selector: "ngtp-effect-blend-mode" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: NgtpWater, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngtp-water',
                    template: `
		<ngt-water-effect *args="[options()]" [camera]="effect.camera()">
			<ngtp-effect-blend-mode />
			<ng-content />
		</ngt-water-effect>
	`,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [NgtArgs, NgtpEffectBlendMode],
                    hostDirectives: [{ directive: NgtpEffect, inputs: ['blendFunction', 'opacity'] }],
                    providers: [provideDefaultEffectOptions({ blendFunction: BlendFunction.NORMAL })],
                }]
        }], ctorParameters: () => [] });

/**
 * Generated bundle index. Do not edit.
 */

export { ASCIIEffect, LensFlareEffect, NgtpASCII, NgtpBloom, NgtpBrightnessContrast, NgtpChromaticAberration, NgtpColorAverage, NgtpColorDepth, NgtpDepth, NgtpDepthOfField, NgtpDotScreen, NgtpEffect, NgtpEffectBlendMode, NgtpEffectComposer, NgtpFXAA, NgtpGlitch, NgtpGodRays, NgtpGrid, NgtpHueSaturation, NgtpLUT, NgtpLensFlare, NgtpNoise, NgtpOutline, NgtpPixelation, NgtpSMAA, NgtpScanline, NgtpSelectiveBloom, NgtpSepia, NgtpShockWave, NgtpTiltShift, NgtpTiltShift2, NgtpToneMapping, NgtpVignette, NgtpWater, TiltShift2Effect, WaterEffect, injectDefaultEffectOptions, provideDefaultEffectOptions };
//# sourceMappingURL=angular-three-postprocessing.mjs.map
